net.sf.saxon.tree.linked

## Class ElementImpl

- java.lang.Object
- - net.sf.saxon.tree.linked.NodeImpl
  - - net.sf.saxon.tree.linked.ElementImpl

- All Implemented Interfaces:
    Source, SourceLocator, PullEvent, FingerprintedNode, Item, MutableNodeInfo, NamespaceResolver, NodeInfo, Sequence, SteppingNode, SiblingCountingNode
  Direct Known Subclasses:
    DataElement, SchemaElement, StyleElement

      public class ElementImpl
      extends NodeImpl
      implements NamespaceResolver

  ElementImpl implements an element with no attributes or namespace declarations.

  This class is an implementation of NodeInfo. For elements with attributes or namespace declarations, class ElementWithAttributes is used.

  Author:
    Michael H. Kay

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.tree.linked.NodeImpl

      `NODE_LETTER`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ElementImpl()` Construct an empty ElementImpl

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addAttribute(NodeName nameCode, SimpleType attType, CharSequence value, int properties)` Add an attribute to this element node.
    `protected void` | `addChild(NodeImpl node, int index)` Add a child node to this node.
    `void` | `addNamespace(NamespaceBinding nscode, boolean inherit)` Add a namespace binding (that is, a namespace node) to this element.
    `void` | `compact(int size)` Compact the space used by this node
    `void` | `copy(Receiver out, int copyOptions, int locationId)` Copy this node to a given outputter (supporting xsl:copy-of)
    `void` | `delete()` Delete this node (that is, detach it from its parent)
    `protected void` | `fixupInsertedNamespaces(boolean inherit)` Ensure that a child element being inserted into a tree has the right namespace declarations.
    `void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node
    `AttributeCollection` | `getAttributeList()` Get the attribute list for this element.
    `String` | `getAttributeValue(int fp)` Get the value of the attribute with a given fingerprint.
    `String` | `getAttributeValue(String uri, String localName)` Get the value of a given attribute of this node
    `String` | `getBaseURI()` Get the base URI of this element node.
    `int` | `getColumnNumber()` Get the line number of the node within its source document entity
    `NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
    `DocumentInfo` | `getDocumentRoot()` Get the root node, if it is a document node.
    `NodeImpl` | `getFirstChild()` Get the first child node of the element
    `NodeImpl` | `getLastChild()` Get the last child node of the element
    `int` | `getLineNumber()` Get the line number of the node within its source document entity
    `int` | `getNameCode()` Get the nameCode of the node.
    `NamespaceBinding[]` | `getNamespaceList()` Get the namespace list for this element.
    `int` | `getNodeKind()` Return the kind of node.
    `protected NodeImpl` | `getNthChild(int n)` Get the nth child node of the element (numbering from 0)
    `int` | `getNumberOfChildren()` Determine how many children the node has
    `String` | `getPrefixForURI(String uri)` Search the NamespaceList for a given URI, returning the corresponding prefix.
    `protected int` | `getRawSequenceNumber()`
    `NodeInfo` | `getRoot()` Get the root node
    `SchemaType` | `getSchemaType()` Get the type annotation
    `protected long` | `getSequenceNumber()` Get the node sequence number (in document order).
    `String` | `getStringValue()` Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.
    `CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
    `String` | `getSystemId()` Get the system ID of the entity containing this element node.
    `int` | `getTypeAnnotation()` Get the fingerpint of the type annotation of this node, if any
    `String` | `getURIForPrefix(String prefix, boolean useDefault)` Get the namespace URI corresponding to a given prefix.
    `AttributeCollection` | `gsetAttributeCollection()` Get the attribute list.
    `boolean` | `hasChildNodes()` Determine if the node has any children.
    `void` | `initialise(NodeName elemName, SchemaType elementType, AttributeCollectionImpl atts, NodeInfo parent, int sequenceNumber)` Initialise a new ElementImpl with an element name
    `void` | `insertChildren(NodeInfo[] source, boolean atStart, boolean inherit)` Insert a sequence of nodes as children of this node.
    `protected void` | `insertChildrenAt(NodeInfo[] source, int index, boolean inherit)` Insert children before or after a given existing child
    `boolean` | `isId()` Determine whether this node has the is-id property
    `boolean` | `isNilled()` Determine whether the node has the is-nilled property
    `protected AxisIterator` | `iterateChildren(NodeTest test)` Get an enumeration of the children of this node
    `Iterator<String>` | `iteratePrefixes()` Get an iterator over all the prefixes declared in this namespace context.
    `void` | `removeAttribute(NodeInfo attribute)` Remove an attribute from this element node
    `protected void` | `removeChild(NodeImpl child)` Remove a given child
    `void` | `removeTypeAnnotation()` Remove type information from this node (and its ancestors, recursively).
    `void` | `rename(NodeName newName)` Rename this node
    `protected void` | `replaceChildrenAt(NodeInfo[] source, int index, boolean inherit)` Replace child at a given index by new children
    `void` | `replaceStringValue(CharSequence stringValue)` Replace the string-value of this node
    `void` | `setAttributeList(AttributeCollection atts)` Set the attribute list
    `protected void` | `setChildren(Object children)` Set the children of this node
    `void` | `setLocation(String systemId, int line, int column)` Set location information for this node
    `void` | `setNameCode(int nameCode)` Set the name code.
    `void` | `setNamespaceDeclarations(NamespaceBinding[] namespaces, int namespacesUsed)` Set the namespace declarations for the element
    `void` | `setNamespaceList(NamespaceBinding[] namespaces)` Set the namespace list
    `protected void` | `setRawSequenceNumber(int seq)`
    `void` | `setSystemId(String uri)` Set the system ID of this node.
    `void` | `setTypeAnnotation(int typeCode)` Set the type annotation on a node.

    - ### Methods inherited from class net.sf.saxon.tree.linked.NodeImpl

      `atomize, compareOrder, comparePosition, equals, getConfiguration, getDisplayName, getDocumentNumber, getFingerprint, getLocalPart, getNamePool, getNextInDocument, getNextSibling, getParent, getPhysicalRoot, getPrefix, getPreviousInDocument, getPreviousSibling, getPublicId, getRawParent, getSiblingPosition, getSuccessorElement, getURI, head, insertSiblings, isDeleted, isIdref, isSameNodeInfo, iterate, iterateAxis, iterateAxis, newBuilder, replace, setRawParent, setSiblingPosition`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `hashCode`

- - ### Constructor Detail

    - #### ElementImpl

          public ElementImpl()

      Construct an empty ElementImpl

  - ### Method Detail

    - #### setNameCode

          public void setNameCode(int nameCode)

      Set the name code. Used when creating a dummy element in the Stripper
      Parameters:
        `nameCode` - the integer name code representing the element name

    - #### setAttributeList

          public void setAttributeList(AttributeCollection atts)

      Set the attribute list
      Parameters:
        `atts` - the list of attributes of this element (not including namespace attributes)

    - #### setNamespaceList

          public void setNamespaceList(NamespaceBinding[] namespaces)

      Set the namespace list
      Parameters:
        `namespaces` - an integer array of namespace codes

    - #### initialise

          public void initialise(NodeName elemName,
                        SchemaType elementType,
                        AttributeCollectionImpl atts,
                        NodeInfo parent,
                        int sequenceNumber)

      Initialise a new ElementImpl with an element name
      Parameters:
        `elemName` - Integer representing the element name, with namespaces resolved
        `elementType` - the schema type of the element node
        `atts` - The attribute list: always null
        `parent` - The parent node
        `sequenceNumber` - Integer identifying this element within the document

    - #### setLocation

          public void setLocation(String systemId,
                         int line,
                         int column)

      Set location information for this node
      Parameters:
        `systemId` - the base URI
        `line` - the line number if known
        `column` - the column number if known

    - #### setSystemId

          public void setSystemId(String uri)

      Set the system ID of this node. This method is provided so that a NodeInfo implements the javax.xml.transform.Source interface, allowing a node to be used directly as the Source of a transformation
      Specified by:
        `setSystemId` in interface `Source`
      Overrides:
        `setSystemId` in class `NodeImpl`

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node
      Specified by:
        `getRoot` in interface `NodeInfo`
      Overrides:
        `getRoot` in class `NodeImpl`
      Returns:
        the NodeInfo representing the logical root of the tree. For this tree implementation the root will either be a document node or an element node.

    - #### getDocumentRoot

          public DocumentInfo getDocumentRoot()

      Get the root node, if it is a document node.
      Specified by:
        `getDocumentRoot` in interface `NodeInfo`
      Overrides:
        `getDocumentRoot` in class `NodeImpl`
      Returns:
        the DocumentInfo representing the containing document. If this node is part of a tree that does not have a document node as its root, returns null.
      Since:
        8.4

    - #### getSystemId

          public final String getSystemId()

      Get the system ID of the entity containing this element node.
      Specified by:
        `getSystemId` in interface `Source`
      Specified by:
        `getSystemId` in interface `SourceLocator`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Overrides:
        `getSystemId` in class `NodeImpl`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.

    - #### getBaseURI

          public String getBaseURI()

      Get the base URI of this element node. This will be the same as the System ID unless xml:base has been used.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Overrides:
        `getBaseURI` in class `NodeImpl`
      Returns:
        the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

    - #### gsetAttributeCollection

          public AttributeCollection gsetAttributeCollection()

      Get the attribute list. Note that if the attribute list is empty, it should not be modified, as it will be shared by other elements. Instead, set a new attribute list.
      Returns:
        the list of attributes of this element (not including namespace attributes)

    - #### isNilled

          public boolean isNilled()

      Determine whether the node has the is-nilled property
      Specified by:
        `isNilled` in interface `NodeInfo`
      Overrides:
        `isNilled` in class `NodeImpl`
      Returns:
        true if the node has the is-nilled property

    - #### setTypeAnnotation

          public void setTypeAnnotation(int typeCode)

      Set the type annotation on a node. This must only be called when the caller has verified (by validation) that the node is a valid instance of the specified type. The call is ignored if the node is not an element or attribute node.
      Specified by:
        `setTypeAnnotation` in interface `MutableNodeInfo`
      Overrides:
        `setTypeAnnotation` in class `NodeImpl`
      Parameters:
        `typeCode` - the type annotation (possibly including high bits set to indicate the isID, isIDREF, and isNilled properties)

    - #### getTypeAnnotation

          public int getTypeAnnotation()

      Get the fingerpint of the type annotation of this node, if any
      Specified by:
        `getTypeAnnotation` in interface `NodeInfo`
      Overrides:
        `getTypeAnnotation` in class `NodeImpl`
      Returns:
        the type annotation, as the integer name code of the type name

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation
      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Overrides:
        `getSchemaType` in class `NodeImpl`
      Returns:
        the type annotation of the node

    - #### getLineNumber

          public int getLineNumber()

      Get the line number of the node within its source document entity
      Specified by:
        `getLineNumber` in interface `SourceLocator`
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Overrides:
        `getLineNumber` in class `NodeImpl`
      Returns:
        the line number of the node in its original source document; or -1 if not available

    - #### getColumnNumber

          public int getColumnNumber()

      Get the line number of the node within its source document entity
      Specified by:
        `getColumnNumber` in interface `SourceLocator`
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Overrides:
        `getColumnNumber` in class `NodeImpl`
      Returns:
        the column number of the node in its original source document; or -1 if not available

    - #### getNameCode

          public int getNameCode()

      Get the nameCode of the node. This is used to locate the name in the NamePool
      Specified by:
        `getNameCode` in interface `NodeInfo`
      Overrides:
        `getNameCode` in class `NodeImpl`
      Returns:
        an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
      See Also:
        `allocate`, `getFingerprint`

    - #### generateId

          public void generateId(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node
      Specified by:
        `generateId` in interface `NodeInfo`
      Overrides:
        `generateId` in class `NodeImpl`
      Parameters:
        `buffer` - to contain the generated ID

    - #### getNodeKind

          public final int getNodeKind()

      Return the kind of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        Type.ELEMENT
      See Also:
        `Type`

    - #### copy

          public void copy(Receiver out,
                  int copyOptions,
                  int locationId)
                    throws XPathException

      Copy this node to a given outputter (supporting xsl:copy-of)
      Specified by:
        `copy` in interface `NodeInfo`
      Parameters:
        `out` - The outputter
        `copyOptions` -
        `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
      Throws:
        `XPathException` - if any downstream error occurs

    - #### delete

          public void delete()

      Delete this node (that is, detach it from its parent)
      Specified by:
        `delete` in interface `MutableNodeInfo`
      Overrides:
        `delete` in class `NodeImpl`

    - #### rename

          public void rename(NodeName newName)

      Rename this node
      Specified by:
        `rename` in interface `MutableNodeInfo`
      Overrides:
        `rename` in class `NodeImpl`
      Parameters:
        `newName` - the new name

    - #### addNamespace

          public void addNamespace(NamespaceBinding nscode,
                          boolean inherit)

      Add a namespace binding (that is, a namespace node) to this element. This call has no effect if applied to a node other than an element.
      Specified by:
        `addNamespace` in interface `MutableNodeInfo`
      Overrides:
        `addNamespace` in class `NodeImpl`
      Parameters:
        `nscode` - The namespace code representing the (prefix, uri) pair of the namespace binding to be added. If the target element already has a namespace binding with this (prefix, uri) pair, the call has no effect. If the target element currently has a namespace binding with this prefix and a different URI, an exception is raised.
        `inherit` - If true, the new namespace binding will be inherited by any children of the target element that do not already have a namespace binding for the specified prefix, recursively. If false, the new namespace binding will not be inherited.
      Throws:
        `IllegalArgumentException` - if the target element already has a namespace binding for this prefix, or if the namespace code represents a namespace undeclaration

    - #### replaceStringValue

          public void replaceStringValue(CharSequence stringValue)

      Replace the string-value of this node
      Specified by:
        `replaceStringValue` in interface `MutableNodeInfo`
      Parameters:
        `stringValue` - the new string value

    - #### addAttribute

          public void addAttribute(NodeName nameCode,
                          SimpleType attType,
                          CharSequence value,
                          int properties)

      Add an attribute to this element node.

      If this node is not an element, or if the supplied node is not an attribute, the method takes no action. If the element already has an attribute with this name, the method throws an exception.

      This method does not perform any namespace fixup. It is the caller's responsibility to ensure that any namespace prefix used in the name of the attribute (or in its value if it has a namespace-sensitive type) is declared on this element.

      Specified by:
        `addAttribute` in interface `MutableNodeInfo`
      Overrides:
        `addAttribute` in class `NodeImpl`
      Parameters:
        `nameCode` - the name of the new attribute
        `attType` - the type annotation of the new attribute
        `value` - the string value of the new attribute
        `properties` - properties including IS_ID and IS_IDREF properties
      Throws:
        `IllegalStateException` - if the element already has an attribute with the given name.

    - #### removeAttribute

          public void removeAttribute(NodeInfo attribute)

      Remove an attribute from this element node

      If this node is not an element, or if the specified node is not an attribute of this element, this method takes no action.

      The attribute object itself becomes unusable; any attempt to use this attribute object, or any other object representing the same node, is likely to result in an exception.

      Specified by:
        `removeAttribute` in interface `MutableNodeInfo`
      Overrides:
        `removeAttribute` in class `NodeImpl`
      Parameters:
        `attribute` - the attribute node to be removed

    - #### removeTypeAnnotation

          public void removeTypeAnnotation()

      Remove type information from this node (and its ancestors, recursively). This method implements the upd:removeType() primitive defined in the XQuery Update specification
      Specified by:
        `removeTypeAnnotation` in interface `MutableNodeInfo`
      Overrides:
        `removeTypeAnnotation` in class `NodeImpl`

    - #### setNamespaceDeclarations

          public void setNamespaceDeclarations(NamespaceBinding[] namespaces,
                                      int namespacesUsed)

      Set the namespace declarations for the element
      Parameters:
        `namespaces` - the list of namespace codes
        `namespacesUsed` - the number of entries in the list that are used

    - #### getURIForPrefix

          public String getURIForPrefix(String prefix,
                               boolean useDefault)

      Get the namespace URI corresponding to a given prefix. Return null if the prefix is not in scope.
      Specified by:
        `getURIForPrefix` in interface `NamespaceResolver`
      Parameters:
        `prefix` - the namespace prefix. May be the zero-length string, indicating that there is no prefix. This indicates either the default namespace or the null namespace, depending on the value of useDefault.
        `useDefault` - true if the default namespace is to be used when the prefix is "". If false, the method returns "" when the prefix is "".
      Returns:
        the uri for the namespace, or null if the prefix is not in scope. The "null namespace" is represented by the pseudo-URI "".

    - #### iteratePrefixes

          public Iterator<String> iteratePrefixes()

      Get an iterator over all the prefixes declared in this namespace context. This will include the default namespace (prefix="") and the XML namespace where appropriate
      Specified by:
        `iteratePrefixes` in interface `NamespaceResolver`
      Returns:
        an iterator over all the prefixes for which a namespace binding exists, including the zero-length string to represent the null/absent prefix if it is bound

    - #### getPrefixForURI

          public String getPrefixForURI(String uri)

      Search the NamespaceList for a given URI, returning the corresponding prefix.
      Parameters:
        `uri` - The URI to be matched.
      Returns:
        The prefix corresponding to this URI. If not found, return null. If there is more than one prefix matching the URI, the first one found is returned. If the URI matches the default namespace, return an empty string.

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Overrides:
        `getDeclaredNamespaces` in class `NodeImpl`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of NamespaceBinding objects representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to null.

        For a node other than an element, the method returns null.

    - #### fixupInsertedNamespaces

          protected void fixupInsertedNamespaces(boolean inherit)

      Ensure that a child element being inserted into a tree has the right namespace declarations. Redundant declarations should be removed. If the child is in the null namespace but the parent has a default namespace, xmlns="" should be added. If inherit is false, namespace undeclarations should be added for all namespaces that are declared on the parent but not on the child.
      Parameters:
        `inherit` - true if the child is to inherit the inscope namespaces of its new parent

    - #### getAttributeList

          public AttributeCollection getAttributeList()

      Get the attribute list for this element.
      Returns:
        The attribute list. This will not include any namespace attributes. The attribute names will be in expanded form, with prefixes replaced by URIs

    - #### getNamespaceList

          public NamespaceBinding[] getNamespaceList()

      Get the namespace list for this element.
      Returns:
        The raw namespace list, as an array of name codes

    - #### getAttributeValue

          public String getAttributeValue(String uri,
                                 String localName)

      Get the value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Overrides:
        `getAttributeValue` in class `NodeImpl`
      Parameters:
        `uri` - the namespace URI of the attribute name, or "" if the attribute is not in a namepsace
        `localName` - the local part of the attribute name
      Returns:
        the attribute value if it exists or null if not

    - #### getAttributeValue

          public String getAttributeValue(int fp)

      Get the value of the attribute with a given fingerprint.
      Specified by:
        `getAttributeValue` in interface `FingerprintedNode`
      Overrides:
        `getAttributeValue` in class `NodeImpl`
      Parameters:
        `fp` - the fingerprint of the required attribute
      Returns:
        the string value of the attribute if present, or null if absent

    - #### isId

          public boolean isId()

      Determine whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Overrides:
        `isId` in class `NodeImpl`
      Returns:
        true if the node is an ID

    - #### getSequenceNumber

          protected final long getSequenceNumber()

      Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. In the current implementation, parent nodes (elements and document nodes) have a zero least-significant word, while namespaces, attributes, text nodes, comments, and PIs have the top word the same as their owner and the bottom half reflecting their relative position. For nodes added by XQUery Update, the sequence number is -1L
      Overrides:
        `getSequenceNumber` in class `NodeImpl`
      Returns:
        the sequence number if there is one, or -1L otherwise.

    - #### getRawSequenceNumber

          protected final int getRawSequenceNumber()

    - #### setRawSequenceNumber

          protected final void setRawSequenceNumber(int seq)

    - #### setChildren

          protected final void setChildren(Object children)

      Set the children of this node
      Parameters:
        `children` - null if there are no children, a single NodeInfo if there is one child, an array of NodeInfo if there are multiple children

    - #### hasChildNodes

          public final boolean hasChildNodes()

      Determine if the node has any children.
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Overrides:
        `hasChildNodes` in class `NodeImpl`
      Returns:
        `true` if the node has any children, `false` if the node has no children.

    - #### getNumberOfChildren

          public final int getNumberOfChildren()

      Determine how many children the node has
      Returns:
        the number of children of this parent node

    - #### iterateChildren

          protected final AxisIterator iterateChildren(NodeTest test)

      Get an enumeration of the children of this node
      Parameters:
        `test` - A NodeTest to be satisfied by the child nodes, or null if all child node are to be returned
      Returns:
        an iterator over the children of this node

    - #### getFirstChild

          public final NodeImpl getFirstChild()

      Get the first child node of the element
      Specified by:
        `getFirstChild` in interface `SteppingNode`
      Overrides:
        `getFirstChild` in class `NodeImpl`
      Returns:
        the first child node of the required type, or null if there are no children

    - #### getLastChild

          public final NodeImpl getLastChild()

      Get the last child node of the element
      Overrides:
        `getLastChild` in class `NodeImpl`
      Returns:
        the last child of the element, or null if there are no children

    - #### getNthChild

          protected final NodeImpl getNthChild(int n)

      Get the nth child node of the element (numbering from 0)
      Parameters:
        `n` - identifies the required child
      Returns:
        the last child of the element, or null if there is no n'th child

    - #### removeChild

          protected void removeChild(NodeImpl child)

      Remove a given child
      Parameters:
        `child` - the child to be removed

    - #### getStringValue

          public String getStringValue()

      Return the string-value of the node, that is, the concatenation of the character content of all descendent elements and text nodes.
      Returns:
        the accumulated character content of the element, including descendant elements.
      See Also:
        `Item.getStringValueCS()`

    - #### getStringValueCS

          public CharSequence getStringValueCS()

      Description copied from class: `NodeImpl`
      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `Item`
      Overrides:
        `getStringValueCS` in class `NodeImpl`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### addChild

          protected void addChild(NodeImpl node,
                      int index)

      Add a child node to this node. For system use only. Note: normalizing adjacent text nodes is the responsibility of the caller.
      Parameters:
        `node` - the node to be added as a child of this node. This must be an instance of `NodeImpl`. It will be modified as a result of this call (by setting its parent property and sibling position)
        `index` - the position where the child is to be added

    - #### insertChildren

          public void insertChildren(NodeInfo[] source,
                            boolean atStart,
                            boolean inherit)

      Insert a sequence of nodes as children of this node.

      This method takes no action unless the target node is a document node or element node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

      The supplied nodes will form the new children. Adjacent text nodes will be merged, and zero-length text nodes removed. The supplied nodes may be modified in situ, for example to change their parent property and to add namespace bindings, or they may be copied, at the discretion of the implementation.

      Specified by:
        `insertChildren` in interface `MutableNodeInfo`
      Overrides:
        `insertChildren` in class `NodeImpl`
      Parameters:
        `source` - the nodes to be inserted. The implementation determines what implementation classes of node it will accept; this implementation will accept text, comment, and processing instruction nodes belonging to any implementation, but elements must be instances of `ElementImpl`. The supplied nodes will be modified in situ, for example to change their parent property and to add namespace bindings, if they are instances of `ElementImpl`; otherwise they will be copied. If the nodes are copied, then on return the supplied source array will contain the copy rather than the original.
        `atStart` - true if the new nodes are to be inserted before existing children; false if they are to be inserted after existing children
        `inherit` - true if the inserted nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
      Throws:
        `IllegalArgumentException` - if the supplied nodes use a node implementation that this implementation does not accept.

    - #### insertChildrenAt

          protected void insertChildrenAt(NodeInfo[] source,
                              int index,
                              boolean inherit)

      Insert children before or after a given existing child
      Parameters:
        `source` - the children to be inserted. We allow any kind of text, comment, or processing instruction node, but element nodes must be instances of this NodeInfo implementation.
        `index` - the position before which they are to be inserted: 0 indicates insertion before the first child, 1 insertion before the second child, and so on.
        `inherit` - true if the inserted nodes are to inherit the namespaces that are in-scope for their new parent; false if such namespaces should be undeclared on the children

    - #### replaceChildrenAt

          protected void replaceChildrenAt(NodeInfo[] source,
                               int index,
                               boolean inherit)

      Replace child at a given index by new children
      Parameters:
        `source` - the children to be inserted
        `index` - the position at which they are to be inserted: 0 indicates replacement of the first child, replacement of the second child, and so on. The effect is undefined if index is out of range
        `inherit` - set to true if the new child elements are to inherit the in-scope namespaces of their new parent
      Throws:
        `IllegalArgumentException` - if any of the replacement nodes is not an element, text, comment, or processing instruction node

    - #### compact

          public void compact(int size)

      Compact the space used by this node
      Parameters:
        `size` - the number of actual children

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.